unit SampleB;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  HReport, HRLinkC, StdCtrls, HRCtrlsC, HRCommon;

type
  TSampleBf = class(TForm)
    HRPageB: THRPage;
    HRPageBand1: THRPageBand;
    HRLabel1: THRLabel;
    HRLink1: THRLink;
    HRGroupBand0: THRGroupBand;
    HRGroup1: THRGroup;
    txPartNo: THRDBText;
    lbPartNo: THRLabel;
    txChildPartNo: THRDBText;
    lbChildPartNo: THRLabel;
    txQty: THRDBText;
    lbQty: THRLabel;
    HRGroupBand1: THRGroupBand;
    HRGroup0: THRGroup;
    txPartNo0: THRDBText;
    lbPartNo1: THRLabel;
    txDescription: THRDBText;
    lbDescription: THRLabel;
    HRGroupBand2: THRGroupBand;
    HRGroup2: THRGroup;
    txPartNo1: THRDBText;
    lbPartNo2: THRLabel;
    txDescription0: THRDBText;
    lbDescription1: THRLabel;
    txListPrice: THRDBText;
    lbListPrice: THRLabel;
    SelfLevel: THRSysData;
    HyperReport1: THyperReport;
    var0: THRDBText;
    var1: THRDBText;
    var2: THRDBText;
    var3: THRDBText;
    HRLabel2: THRLabel;
    lb: THRLabel;
    varQty: THRDBText;
    HRGroupBand3: THRGroupBand;
    cl: THRCalc;
    procedure SelfLevelBeforePrint(Sender: THRCustomLabel;
      var Value: string);
    procedure HyperReport1BeforeReport(Sender: TObject;
      var PrintReport: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SampleBf: TSampleBf;

implementation

uses SampleD;

{$R *.DFM}
var
  LevelQty:array[0..10] of integer;
  PrevLevel: integer;

procedure TSampleBf.HyperReport1BeforeReport(Sender: TObject;
  var PrintReport: Boolean);
begin
  PrevLevel := -1;
end;

procedure TSampleBf.SelfLevelBeforePrint(Sender: THRCustomLabel;
  var Value: string);
var
  CurLevel: integer;
begin
  CurLevel := StrToInt(Value);
  var0.Value := '';
  var1.Value := '';
  var2.Value := '';
  var3.Value := '';
  case CurLevel of
    0: var0.Value := '0';
    1: var1.Value := '1';
    2: var2.Value := '2';
    3: var3.Value := '3';
  end;
  if (CurLevel < 0) then begin
      varQty.Enabled := False;
      varQty.Value := 0;
  end else if (CurLevel = 0) then begin
      varQty.Enabled := True;
      varQty.Value := SampleDf.BOMQty.asInteger;
      LevelQty[CurLevel] := varQty.Value;
  end else begin
      varQty.Enabled := True;
      varQty.Value := SampleDf.BOMQty.asInteger * LevelQty[CurLevel-1];
      LevelQty[CurLevel] := varQty.Value;
  end;
end;

end.
